<?php
/** 
* Class to create custom post type wao license manager 
* @package WAOLM 
*/

/** 
* Create new post type for autodispatched keys 
* consta de tres funciones
* - autodipatch_post_type (crea el post type Keys)
* - personalizar_columnas  (crea las columnas en la parte del listado)
* - personalizar_contenidos (lee los valores desde post_meta y los plasma en la tabla)
* - ordenamiento
* --- keys_sortable_columns
* --- keys_load
* --- my_sort_keys
* - registro de metaboxes para la vista de edicion o adicion
* --- kfp_licensemanagerwao_register_meta_boxes
* --- kfp_licensemanagerwao_output_meta_box
* --- kfp_licensemanagerwao_save_meta_boxes
* @since 1.2.0 
*/

// Exit if accessed directly 
if( ! defined( 'ABSPATH' ) ) {
    exit;
}
if( ! class_exists( 'WAOLM_Admin' ) ) {
    class WAOLM_Admin {
        public function __construct() {
        }
        public function init() {
			/// Creacion del custom post type licensemanagerwao
			add_action('init', array( $this, 'autodipatch_post_type'));
			/// Personalizacion de columnas
			add_filter( 'manage_licensemanagerwao_posts_columns', array( $this, 'personalizar_columnas') );
			/// Cargar contenidos en la tabla
			add_action( 'manage_licensemanagerwao_posts_custom_column', array( $this, 'personalizar_contenidos'), 10, 2);
			/// Ordenacion de columna
			add_filter( 'manage_edit-licensemanagerwao_sortable_columns', array( $this, 'keys_sortable_columns') );
			add_action( 'load-edit.php', array( $this, 'keys_load') );
			/// Salvar la informacion
			add_action('save_post', array( $this, 'kfp_licensemanagerwao_save_meta_boxes'));
			/// Colocar un input select en la fila de filtros del listado CPT
			add_action('restrict_manage_posts',array( $this, 'location_filtering'),10);
			/// Mantener el filtrado realizado mediante un input select en el listado CPT
			add_filter( 'parse_query', array( $this, 'filter_request_query') , 10);
			/// Agregar metaboxes en la pantalla de edicion del CPT
			add_action('add_meta_boxes', array( $this, 'kfp_licensemanagerwao_register_meta_boxes'));
			/// Mostrar las llaves compradas por el cliente en la pagina de edit order
			add_action('woocommerce_admin_order_data_after_order_details',array( $this, 'susllaves'));//sale en edit de order
			/// Submenú de configuracion
			add_action( 'admin_menu', array( $this, 'mi_submenu') );
//add_filter( 'wp_statuses_get_registered_post_types', $this->restrict_statuses_for_licensemanagerwao, 10, 2 );
//add_filter( 'wp_insert_post_data', $this->insert_using_custom_status, 10, 2 );

      }
//////////////////////////////////AQUI EMPIEZAN LAS FUNCIONES/////////////////////////////////////////////////

function insert_using_custom_statusX( $data = array(), $postarr = array() ) {

	if ( empty( $postarr['publish'] ) ) {
		return $data;
	}

	if ( 'licensemanagerwao' !== $data['post_type'] ) {
		return $data;
	}

	if ( ! empty( $postarr['_wp_statuses_status'] ) && in_array( $postarr['_wp_statuses_status'], array(
		'Active',
		'Inactive',
	), true ) ) {
		$data['post_status'] = sanitize_key( $postarr['_wp_statuses_status'] );

	// Default status for the licensemanagerwao Post Type is assigned.
	} else {
		$data['post_status'] = 'Publish';
	}

	return $data;
}

function restrict_statuses_for_licensemanagerwaoX( $post_types = array(), $status_name = '' ) {
	if ( 'Active' === $status_name || 'Inactive' === $status_name ) {
		return $post_types;
	}
	// All other statuses (eg: Publish, Private...) won't be applied to tickets
	return array_diff( $post_types, array( 'licensemanagerwao' ) );
}


	function autodipatch_post_type()
	{
		$args = array(
			'public' => true,
			'labels' => array(
				'name' => 'WAO License Manager',
				'singular_name' => 'Key',
				'all_items' => 'All Keys',
				'add_new' => 'Add new Key',
				'add_new_item' => 'Add new Key',
				'edit_item' => 'Edit Key',
				'new_item' => 'New Key',
				'view_item' => 'View Key',
				'search_items' => 'Search Keys',
				'not_found' => 'Keys not found',
				'not_found_in_trash' => 'Keys not found in trash'
			),
			'menu_position' => 12,
			'capability_type' => 'post',
			'menu_icon' => 'dashicons-products',
			'supports' => array( 'title'	 )
			
		);
		register_post_type('licensemanagerwao', $args);

	/*register_post_status( 'Active', array(
		'label'                     => _x( 'Active', 'post status label', 'licensemanagerwao' ),
		'public'                    => true,
		'label_count'               => _n_noop( 'Active <span class="count">(%s)</span>', 'Resolved <span class="count">(%s)</span>', 'plugin-domain' ),
		'post_type'                 => array( 'licensemanagerwao' ), // Define one or more post types the status can be applied to.
		'show_in_admin_all_list'    => true,
		'show_in_admin_status_list' => true,
		'show_in_metabox_dropdown'  => true,
		'show_in_inline_dropdown'   => true,
		'dashicon'                  => 'dashicons-yes',
	) );

	register_post_status( 'Inactive', array(
		'label'                     => _x( 'Inactive', 'post status label', 'licensemanagerwao' ),
		'public'                    => true,
		'label_count'               => _n_noop( 'Invalid <span class="count">(%s)</span>', 'Invalids <span class="count">(%s)</span>', 'plugin-domain' ),
		'post_type'                 => array( 'licensemanagerwao' ), // Define one or more post types the status can be applied to.
		'show_in_admin_all_list'    => true,
		'show_in_admin_status_list' => true,
		'show_in_metabox_dropdown'  => true,
		'show_in_inline_dropdown'   => true,
		'dashicon'                  => 'dashicons-dismiss',
	) );*/



	}// function register_new_post_type END
	
	function personalizar_columnas( $columns ) 
	{
		$columns1 = array(
		  //'Key' => __( 'Key', 'waolicensemanager' ),
		  'Product' => __( 'Product', 'waolicensemanager' ),
		  'Activations' => __( 'Activations', 'waolicensemanager' ),
		  'Dispatched' => __( 'Dispatched', 'waolicensemanager' ),
		  'Status' => __( 'Status', 'waolicensemanager' ),
		  'Priority' => __( 'Priority', 'waolicensemanager' )
		);
		//  'Rotation' => __( 'Rotation', 'waolicensemanager' ),
		$columns=array_merge($columns, $columns1);
	  return $columns;
	}//function personalizar columna END

	function personalizar_contenidos( $column, $post_id ) 
	{
	  $info = get_post_meta($post_id);
	  $info1 = get_post($post_id);
	  switch ($column)
	  {
		case 'Key':
			echo $info['_key'][0];
		  break;
		case 'Product':
			//$pro=get_post($info['_product'][0]);
			//echo $pro->post_name;
			echo $info['_product_name'][0];
		  break;
		case 'Activations':
			echo $info['_activations'][0];
		  break;
		case 'Dispatched':
			echo $info['_dispatched'][0];
		  break;
		case 'Status':
			$valor=$info1->post_status=='publish'?'Active':'Inactive';
			echo $valor;
			//echo $info1->post_status;
		  break;
		case 'Priority':
			//echo $info['_priority'][0];//muestra el metavalor
			echo $info1->menu_order;//muestra menu_order de posts
		  break;
	  }
	}//function personalizar contenidos END

	function keys_sortable_columns( $columns ) 
	{
	 $columns['Product'] = 'Product';
	 $columns['Priority'] = 'Priority';
	 return $columns;
	}//function keys sortable columns END
	
	/* Only run our customization on the 'edit.php' page in the admin. */

	function keys_load() 
	{
	 add_filter( 'request', array( $this, 'my_sort_keys') );
	}//function keys load END 

	/* Sorts  licensemanagerwao. */
	function my_sort_keys( $vars ) 
	{

		/* Check if we're viewing the 'licensemanagerwao' post type. */
		if ( isset( $vars['post_type'] ) && 'licensemanagerwao' == $vars['post_type'] ) {
			/* Check if 'orderby' is set to 'Product'. */
			if ( isset( $vars['orderby'] ) && 'Product' == $vars['orderby'] ) {
				/* Merge the query vars with our custom variables. */
				$vars = array_merge(
				$vars,
				array(
					 'meta_key' => '_product_name',
					 'orderby' => '_product_name'
					)
					//meta_value_num
				);
			}

			/* Check if 'orderby' is set to 'Priority'. */
			if ( isset( $vars['orderby'] ) && 'Priority' == $vars['orderby'] ) {
				/* Merge the query vars with our custom variables. */
				$vars = array_merge(
				$vars,
				array(
					 'meta_key' => '_priority',
					 'orderby' => '_priority'
					)
				);
			}

		}
	 return $vars; 
	}//function my sort keys END		

/// COLOCAR UN INPUT SELECT EN LA FILA DE FILTROS DEL LISTADO DE CPT
	function location_filtering($post_type)
	{
		if('licensemanagerwao' !== $post_type){
		  return; //filter your post
		}
		$selected = '';
		$request_attr = 'my_products';
		if ( isset($_REQUEST[$request_attr]) ) {
		  $selected = $_REQUEST[$request_attr];
		}
		//get unique values of the meta field to filer by.
		$meta_key = '_product';
		global $wpdb;
		
		$result = $wpdb->get_results( 
			$wpdb->prepare( "
				SELECT DISTINCT M.meta_value AS prod, N.meta_value AS productname
					FROM {$wpdb->prefix}posts P 
						LEFT JOIN {$wpdb->prefix}postmeta M ON P.ID = M.post_id AND M.meta_key = '%s' 
						LEFT JOIN {$wpdb->prefix}postmeta N ON P.ID = N.post_id AND N.meta_key = '_product_name'
					WHERE P.post_type = 'licensemanagerwao'
					  AND P.post_status IN ('publish')
					ORDER BY productname", 
				$meta_key
			) 
		);
	   //build a  custom dropdown list of values to filter by
		echo '<select id="my_products" name="my_products">';
		echo '<option value="0">' . __( 'Show all products', 'my-custom-domain' ) . ' </option>';
		foreach($result as $location){
		  //$select = ($org->ID == $selected) ? ' selected="selected"':'';
		  $select = ($location->prod == $selected) ? ' selected="selected"':'';
		  echo '<option value="'.$location->prod.'"'.$select.'>' . $location->productname . ' </option>';
		}
		echo '</select>';
	  }

/// next we need to ensure the admin query returns the correct set of filtered posts by hooking onto the ‘parse_query’ filter
	function filter_request_query($query)
	{
		//modify the query only if it admin and main query.
		if( !(is_admin() AND $query->is_main_query()) ){ 
		  return $query;
		}
		//we want to modify the query for the targeted custom post and filter option
		if( !('licensemanagerwao' === $query->query['post_type'] AND isset($_REQUEST['my_products']) ) ){
		  return $query;
		}
		//for the default value of our filter no modification is required
		if(0 == $_REQUEST['my_products']){
		  return $query;
		}

		//List posts this user is "tagged" in (B).
		$query->set('meta_key', '_product');
		$query->set('meta_value', $_REQUEST['my_products']);
		$query->set('meta_compare', 'LIKE');
		
		return $query;
	  }

/**
 * 2.1.-Agrega los meta boxes para el Custom Post Type licensemanagerwao
 * https://developer.wordpress.org/reference/functions/add_meta_box/
 */

	function kfp_licensemanagerwao_register_meta_boxes()
	{
		add_meta_box('Key-Information', 'Key Information', array( $this, 'kfp_licensemanagerwao_output_meta_box'), 'licensemanagerwao', 'normal', 'high');
	}

/**
 * 2.2 Genera el contenido que hay que mostrar dentro del meta box
 * @param WP_Post $post WordPress Post object
 */

	function kfp_licensemanagerwao_output_meta_box($post)
	{
		// Los campos se graban en la base de datos con un subrayado bajo como prefijo
		// WP indica así por defecto que son campos metas
		$key = get_post_meta($post->ID, '_key', true);
		$product = get_post_meta($post->ID, '_product', true);
		$activations = get_post_meta($post->ID, '_activations', true);
		$dispatched = get_post_meta($post->ID, '_dispatched', true);
		$status = get_post_status($post->ID);
		$priority = get_post_meta($post->ID, '_priority', true);
		wp_nonce_field( 'graba_licensemanagerwao', 'licensemanagerwao_nonce' );
		$sino=true;
		$estilo="margin-left:50px;width:200px;";
	 
			$args = array(
				'numberposts'	=> 50,
				'post_type'		=> 'product',
				'post_status'	=> 'publish',
				'orderby'		=> 'post_name',
				'order'			=>	'ASC'
			);
			$productos = get_posts( $args );
			$ids = array_column($productos, 'ID');
			$names = array_column($productos, 'post_name');
			$prods = array_combine($ids, $names);
//			echo "<h1>hola</h1>";
	/*<select products>*/    
			woocommerce_wp_select(
				array(
					'id'		=> 'product',
					'label'		=> __( 'Product', 'waolicensemanager' ),
					'wrapper_class'	=> $clase,
					'style'		=> "margin-left:68px;width:400px;",
					'value'		=> $product,
					'options'	=>	$prods,
					'desc_tip'	=> $sino,
					'description'	=> __( 'Product that correspond this key.', 'waolicensemanager' )
				)
			);

	/*<input text activations>*/    
			woocommerce_wp_text_input(
				array(
					'id'		=> 'activations',
					'label'		=> __( 'Activations', 'waolicensemanager' ),
					'wrapper_class'	=> $clase,
					'style'		=> "margin-left:50px;width:400px;",
					'type'		=> 'number',
					'value'		=> esc_attr($activations),
					'desc_tip'	=> $sino,
					'description'	=> __( 'Number of total activations for this key.', 'waolicensemanager' )
				)
			);

	/*<input text dispatched>*/    
			woocommerce_wp_text_input(
				array(
					'id'		=> 'dispatched',
					'label'		=> __( 'Dispatched', 'waolicensemanager' ),
					'wrapper_class'	=> $clase,
					'style'		=> "margin-left:50px;width:400px;",
					'type'		=> 'number',
					'value'		=> esc_attr($dispatched),
					'desc_tip'	=> $sino,
					'custom_attributes' => array('readonly' => 'readonly'),
					'description'	=> __( 'Number of activations done for this key.', 'waolicensemanager' )
				)
			);
	/*<input text priority>*/    
			woocommerce_wp_text_input(
				array(
					'id'		=> 'priority',
					'label'		=> __( 'Priority', 'waolicensemanager' ),
					'wrapper_class'	=> $clase,
					'style'		=> "margin-left:72px;width:400px;",
					'type'		=> 'number',
					'value'		=> esc_attr($priority),
					'desc_tip'	=> $sino,
					'description'	=> __( 'Priority', 'waolicensemanager' )
				)
			);
	/*<select status>*/
			if($status <> "publish"){$status="draft";}
			$estados['publish']="Active";
			$estados['draft']="Inactive";
			woocommerce_wp_select(
				array(
					'id'		=> 'status',
					'label'		=> __( 'Status', 'waolicensemanager' ),
					'wrapper_class'	=> $clase,
					'style'		=> "margin-left:75px;width:400px;",
					'value'		=> $status,
					'options'	=>	$estados,
					'desc_tip'	=> $sino,
					'description'	=> __( 'Select the status.', 'waolicensemanager' )
				)
			);



	}

/**
 * 2.3 Graba los campos del formulario del meta box
 * @param int $post_id Post ID
 * @return bool|int
 */

	function kfp_licensemanagerwao_save_meta_boxes($post_id)
	{
		// Comprueba que el nonce es correcto para evitar ataques CSRF
		if ( !isset($_POST['licensemanagerwao_nonce']) || ! wp_verify_nonce( $_POST['licensemanagerwao_nonce'], 'graba_licensemanagerwao') ) {
			return $post_id;
		}

		// Comprueba que el tipo de post es licensemanagerwaos
		if ('licensemanagerwao' != $_POST['post_type']) {
			return $post_id;
		}

		// Comprueba que el usuario actual tiene permiso para editar esto
		if (!current_user_can('edit_post', $post_id)) {
			return $post_id;
		}

		// Ahora puedes grabar los datos con tranquilidad
		// Observa que cuando vienen del formulario los campos meta no vienen con el prefijo subrayado bajo pero cuando los grabas en el post hay que poner el prefijo, igual que cuando los leías del post
		$key = get_post_meta($post->ID, '_key', true);
		$product = get_post_meta($post->ID, '_product', true);
		$activations = get_post_meta($post->ID, '_activations', true);
		$dispatched = get_post_meta($post->ID, '_dispatched', true);
		//$rotation = get_post_meta($post->ID, '_rotation', true);
		$priority = get_post_meta($post->ID, '_priority', true);

		$key = sanitize_text_field($_POST['key']);
		update_post_meta($post_id, '_key', $key);
		$product = sanitize_text_field($_POST['product']);
		update_post_meta($post_id, '_product', $product);
		$product_name = get_post( $product );
		update_post_meta($post_id, '_product_name', $product_name->post_name);
		$activations = sanitize_text_field($_POST['activations']);
		update_post_meta($post_id, '_activations', $activations);
		$dispatched = sanitize_text_field($_POST['dispatched']);
		update_post_meta($post_id, '_dispatched', $dispatched);

		//esto ya no sera necesario ....
		$priority = sanitize_text_field($_POST['priority']);
		update_post_meta($post_id, '_priority', $priority);

		$status = sanitize_text_field($_POST['status']);
		global $wpdb;
		$q="UPDATE {$wpdb->prefix}posts SET post_status = '{$status}', menu_order = '{$priority}' WHERE ID = {$post_id}";
		echo $q;
		$wpdb->get_var($q);
		return true;
	}


	function susllaves($post)
	{//sale en edit de order
		$res1=get_post_meta( $post->id,'_keys' );
		$res=$res1[0];
		//print_r($res);
		//echo "<br>";
		if(!empty($res1)){
			$salida="<p class='form-field form-field-wide wc-customer-user'>________</p><h3>".__('The Keys:','woocommerce')."</h3>";
			foreach($res as $grupo){
				$salida.="<ul style='list-style: square;margin-left:30px;'>";
				foreach($grupo as $fila){
					$salida.="<li>".$fila->productname.":  <b>".$fila->skey."</b></li>";
				}//foreach fila END
				$salida.="</ul>";
			}// foreach grupo END
			echo  $salida;
			
		}

	}	

	// Agrega un submenú de configuración
	// PARAMETROS: 
	// add_submenu_page( string $parent_slug, string $page_title, string $menu_title, 
	// string $capability, string $menu_slug, callable $callback = '', int|float $position = null ):string|false
	function mi_submenu(){
	//		add_dashboard_page(
	// La funcion wao_settings_page se encuentra fuera de la clase. :(
		add_submenu_page(
			'edit.php?post_type=licensemanagerwao',
			__( 'WLM Settings', 'licensemanagerwao' ),
			__( 'WLM Settings', 'licensemanagerwao' ),
			'manage_options',
			'WAOLMsettings',
			'wao_settings_page'
		);
	}

//////////////////////////////////AQUI TERMINAN LAS FUNCIONES/////////////////////////////////////////////////

    }// fin de clase
}// fin de si existe clase

/*
* PAGINA DE CONFIGURACION DE PARAMETROS PARA WAO LICENSE MANAGER
*/
	
function wao_settings_page(){
	?>
	<form action="options.php" method="post">
		<?php 
		settings_fields( '_waolm_options' ); //Llamamos a la seccion de configuracion definida con register_setting()
		do_settings_sections( 'waolm_fields' ); //Mostramos la sección definida con add_settings_section
		?>
		<input name="submit" class="button button-primary" type="submit" value="<?php esc_attr_e( 'Save' ); ?>" />
		<hr>
  </form>
	<?php
} // function wao_settings_page() END


  //////REGISTRANDO LOS CAMPOS O VARIABLES EN LA BASE DE DATOS [PASO 1]

  function waolm_register_settings() {
	
	// REGISTRAMOS UNA PAGINA DE CONFIGURACION
	//register_setting( string  $option_group , string  $ option_name , array  $args  =  array()  )
    register_setting( '_waolm_options', '_waolm_options', '_waolm_options_validate' );

	// CREAMOS UNA SECCION DENTRO LA PAGINA DE CONFIGURACION
    // add_settings_section( cadena  $id , cadena  $título , $devolución de llamada invocable  , cadena $página , matriz $argumentos  =  matriz()  )  
	// Muestre las secciones de configuración en la función de devolución de llamada de su página de administración con do_settings_sections() .
	// Agregue campos de configuración a su sección con add_settings_field() . 
	add_settings_section( 'waolm1_settings', 'Windows And Office License Manager Settings', 'waolm_section_text', 'waolm_fields' );

	// INSERTAMOS CADA INPUT, MEDIANTE UNA FUNCION EXTERNA.
	// add_settings_field( string $id, string $title, callable $callback, string $page, string $section = 'default', array $args = array() )
	// Un add_settings_field asociado a una settings_secction por cada campo de configuración.
	// Por cada uno, hay una función separada para insertar un input.
     add_settings_field( 'waolm_setting_urlmanuals', 'URL raiz para el enlace a manual de usuario y descargas', 'waolm_setting_urlmanuals', 'waolm_fields', 'waolm1_settings' );
	  
  }
  add_action( 'admin_init', 'waolm_register_settings' );

  /////VALIDACION

  function _waolm_options_validate( $input ) {
      $newinput['urlmanuals'] = trim( $input['urlmanuals'] );
      if ( ! preg_match( '/^[a-z0-9]{32}$/i', $newinput['urlmanuals'] ) ) {
          $newinput['urlmanuals'] = '';
      }
      //return $newinput;
      return $input;
  }

  //////////LOS CAMPOS DEL FORMULARIO, LOS QUE SE VEN [PASO 2]
  function waolm_section_text() {
      echo '<p>Configuracion de Parametros para WAO License Manager</p>';
  }

  function waolm_setting_urlmanuals() { // Combos (COMBO#SKU|ID*ID)
      $options = get_option( '_waolm_options' );
      echo "<input id='waolm_urlmanuals' name='_waolm_options[urlmanuals]' type='text' style='width:400px;'; value='".esc_attr( $options['urlmanuals'] )."' /> ";
  }

